#  Copyright (c) 2006 Six Feet Up, Inc.
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
"""
A folder based on ATFolder that can contain Ads
"""
from Products.ATContentTypes.content.folder import ATFolder
from Products.ATContentTypes.content.folder import ATFolderSchema
from Products.Archetypes.public import Schema
from Products.Archetypes.public import registerType
from Products.Archetypes.public import IntegerField, IntegerWidget
from config import PROJECTNAME

ATFolderSchemaCopy = ATFolderSchema.copy()

schema = ATFolderSchemaCopy + Schema((
    IntegerField(
        'width',
        default = 145,
        widget=IntegerWidget(
            label = 'Width',
            description = 'Enter a max width for ads in this folder',
        ),
     ),
    IntegerField(
        'height',
        default = 1000,
        widget=IntegerWidget(
            label = 'Height',
            description = 'Enter a max height for ads in this folder',
        ),
    ),
))

class AdFolder(ATFolder):
    """A custom folder to replace the standard skinned folder and the plone folder
    """
    schema = schema
    global_allow = 0
    archetype_name = portal_type = meta_type = 'Ad Folder'
    allowed_content_types = ['Ad', 'Ad Folder']
    # override to use base view (ad_folder_view) until a catalog solution arises
    immediate_view = 'base_view'
    default_view   = 'base_view'
    suppl_views    = ()
    
    __implements__ = ATFolder.__implements__
    
    # make sure this object doesn't get cataloged/referenced
    # it does however get catalogued in the ad_catalog

    isReferenceable = None
    
    # reference register / unregister methods
    def _register(self, *args, **kwargs): pass
    def _unregister(self, *args, **kwargs): pass
    def _updateCatalog(self, *args, **kwargs): pass
    def _referenceApply(self, *args, **kwargs): pass
    def _uncatalogUID(self, *args, **kwargs): pass
    def _uncatalogRefs(self, *args, **kwargs): pass
    
    # catalog methods
    def indexObject(self, *args, **kwargs): pass
    def unindexObject(self, *args, **kwargs): pass
    def reindexObject(self, *args, **kwargs): pass

registerType(AdFolder, PROJECTNAME)
